%define sub_version rc2
Name: openCryptoki
Summary: Implementation of Cryptoki v2.11 for IBM Crypto Hardware
Version: 2.1.6
Release: 0.40.6
License: Other License(s), see package
Group: Productivity/Security
Source: openCryptoki-%{version}-%{sub_version}.tar.bz2
Source1: pkcsslotd.init
Patch0: openCryptoki-2.1.5-perms.patch
Patch1: openCryptoki-2.1.5-lock_mutex.patch
Patch2: openCryptoki-2.1.6-rc2-ock_add_free_mech_list_20060130.patch
Patch3: openCryptoki-2.1.6-rc2-syslog.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=415971
Patch4: openCryptoki-2.1.6-rc2-memcmp.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=430594
Patch5: openCryptoki-2.1.6-rc2-spinlock.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=430643
Patch6: openCryptoki-2.1.6-rc2-no-hw-crypto.patch
Url: http://oss.software.ibm.com/developerworks/opensource/opencryptoki
BuildRoot: %{_tmppath}/%{name}-%{version}-build
PreReq: shadow-utils coreutils sed
BuildPreReq: openssl-devel >= 0.9.7a-28
ExclusiveArch: s390 s390x
%ifarch s390x
Requires: PKCS11_API.so PKCS11_ICA.so  
%endif

%description
The PKCS#11 Version 2.11 api implemented for the IBM Crypto cards.
This package includes support for the IBM 4758 Cryptographic
CoProcessor (with the PKCS#11 firmware loaded) and the IBM eServer
Cryptographic Accelerator (FC 4960 on pSeries)

Summary:      Implementation of PKCS#11 (Cryptoki) v2.11 for IBM Crypto Hardware
Group:        Productivity/Security

%prep
%setup -q -n openCryptoki-%{version}-%{sub_version}
%patch0 -p1 -b .perms
%patch1 -p1 -b .lock_mutex
%patch2 -p1 -b .ock_add_free_mech_list_20060130
%patch3 -p1 -b .syslog
%patch4 -p1 -b .memcmp
%patch5 -p1 -b .spinlock
%patch6 -p1 -b .no-hw-crypto

%build
autoreconf --force --install
./configure --libdir=%{_libdir}
make -f Makefile

%install
# according to the stuff, / can not be build root... So
# if build root is set, then we can muck with it
if [[ $RPM_BUILD_ROOT  ]] ;
then
	rm -rf $RPM_BUILD_ROOT
	mkdir -p $RPM_BUILD_ROOT
        # the makefiles want INSROOT set for an alternative install path
	export INSROOT=$RPM_BUILD_ROOT
fi
make -f Makefile install
%ifarch s390
mkdir -p $RPM_BUILD_ROOT/usr/include
cp -a usr/include/pkcs11 $RPM_BUILD_ROOT/usr/include
chmod 755 $RPM_BUILD_ROOT/usr/include/pkcs11
chmod 755 $RPM_BUILD_ROOT/usr/include/pkcs11/stdll

# Install initscript
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/pkcsslotd
%endif

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%pre
/usr/sbin/groupadd -r pkcs11 2>/dev/null || true
/usr/sbin/usermod -G $(/usr/bin/id --groups --name root | /bin/sed -e '
# add the pkcs group if it is missing
/(^| )pkcs11( |$)/!s/$/ pkcs11/
# replace spaces by commas
y/ /,/
'),pkcs11  root

%files
%defattr(-,root,root)
%ifarch s390
%{_sysconfdir}/rc.d/init.d/pkcsslotd
%{_sbindir}/pkcsslotd
%{_libdir}/pkcs11/methods/pkcs11_startup
%{_libdir}/pkcs11/methods/pkcsconf
%{_libdir}/pkcs11/methods/pkcs_slot
%{_libdir}/pkcs11/PKCS11_API.so
%{_libdir}/pkcs11/stdll/PKCS11_ICA.so
%{_includedir}/pkcs11
%else
/usr/lib/pkcs11/PKCS11_API.so64
/usr/lib/pkcs11/stdll/PKCS11_ICA.so64
%endif

%changelog
* Mon Oct 11 2010 Dan Horák <dhorak@redhat.com> 2.1.6-rc2.0.40.6
- wrong validation of PIN in pkcsconf (#415971)
- fix file handle exhaustion (#430594)
- work also without HW crypto card (#430643)
- Resolves: #415971, #430594, #430643

* Tue Sep 19 2006 Phil Knirsch <pknirsch@redhat.com> 2.1.6-rc2.0.40.5
- Removed extra syslog call (#177460)

* Thu Feb 02 2006 Phil Knirsch <pknirsch@redhat.com> 2.1.6-rc2.0.40.3
- Fix memory leak for IBM Tivoli Access Manager WebSEAL 6.0 (#179715)

* Tue Jan 31 2006 Phil Knirsch <pknirsch@redhat.com> 2.1.6-rc2.0.40.2
- Fixed segmentation fault with Symmetric crypto (#177458)

* Thu Oct 20 2005 Phil Knirsch <pknirsch@redhat.com> 2.1.6-rc2.0.40.1
- Update to openCryptoki-2.1.6-rc2 (#170708)

* Tue Apr 12 2005 Phil Knirsch <pknirsch@redhat.com> 2.1.5-6.8.40.2
- Updated fix for bug #145451

* Tue Feb 15 2005 Phil Knirsch <pknirsch@redhat.com> 2.1.5-6.8.40.1
- Fixed permissions of /etc/pkcs11/lite/TOK_OBJ dir (#145451)

* Mon Sep 27 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.5-6.8
- Fixed segfault for service status check of pkcsslotd (#133091)

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Jun 15 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.5-6.1
- Updated to latest upstream version openCryptoki-2.1.5-6.tar.bz2

* Tue May 11 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.5-2
- Added requires for 32bit packages for 64bit package.

* Wed Apr 07 2004 Phil Knirsch <pknirsch@redhat.com>
- Update to latest version from IBM which includes important fixes (#119363)
- Create pkcs11 group.

* Thu Mar 25 2004 Tim Powers <timp@redhat.com> 2.1.3-12
- rebuilt to fix broken deps

* Tue Mar 16 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-11
- rebuilt

* Thu Mar 04 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-10
- Converted initsc
ript to UNIX file format, was in DOS.

* Wed Mar 03 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-9
- Minor fixes to pkcsslotd initscript.
- Really fixed permissions this time for initscript.

* Thu Feb 26 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-8
- Included updated initscript from IBM (#112542).
- Changed permission of /etc/init.d/pkcsslotd to be executable (#112542).

* Sat Feb 21 2004 Florian La Roche <Florian.LaRoche@redhat.de>
- mv /etc/init.d -> /etc/rc.d/init.d

* Thu Feb 19 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-7
- rebuilt

* Wed Feb 18 2004 Phil Knirsch <pknirsch@redhat.com>  2.1.3-6
- Fixed small bug in files section.

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Feb 11 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-4
- Fixed some smaller build problems.
- Included and fixed new initscript for pkcs11 startup.
- Fixed filelist.

* Thu Jan 15 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-3
- rebuilt

* Thu Jan 15 2004 Phil Knirsch <pknirsch@redhat.com> 2.1.3-2
- Fixed missing defattr (#113343).

* Tue Nov 11 2003 Phil Knirsch <pknirsch@redhat.com> 2.1.3-1
- Initial Red Hat package.
